project(
  'rrr.v2', 
  'cpp', 
  version : '2.0.0',
  default_options : [
    'warning_level=1',
    'optimization=3',
    'default_library=static',
    'cpp_std=c++20',
])

add_project_arguments (
  '-Wpedantic',
  '-Wno-shadow', 
  '-Wno-unused-but-set-variable',
  '-Wno-comment',
  '-Wno-unused-parameter',
  '-Wno-unused-value',
  '-Wno-missing-field-initializers',
  '-Wno-narrowing',
  '-Wno-deprecated-enum-enum-conversion',
  '-Wno-volatile',
  '-Wno-deprecated-declarations',
  language: 'cpp'
)

#############################################################

args = []

deps = [
  dependency('TBB'),
  dependency('OpenCV'),
  dependency('uuid'),
  dependency('threads'),
  dependency('opengl'),
  subproject('glfw').get_variable('glfw_dep'),
  subproject('glad').get_variable('glad_dep'),
  subproject('hack').get_variable('logger_dep'),
  subproject('try_engine').get_variable('try_engine_dep'),
  subproject('imgui').get_variable('imgui_dep'),
  subproject('glm').get_variable('glm_dep'),
  subproject('nlohmann_json').get_variable('nlohmann_json_dep'),
  subproject('taglib').get_variable('taglib_dep'),
]

inc = []

#############################################################

subdir('src')
subdir('bin')
#subdir('tests')
